require 'matrix'
srand(0)
N=16
E_AB=-1.0
#E_AB=+1.0
EnergyMap=[[0,E_AB],[E_AB,0]]
Temp=0.01
N_loop=1000

$count=0
def print_route(a)
  cont=""
  for i in 0..N-1 do
    for j in 0..N-1 do
      cont << sprintf("%3d",a[i][j])
    end
    cont << sprintf("\n")
  end
  file_name="plots2/tmp"+$count.to_s+".txt"
  f1=File.open(file_name,"w")
  f1.print cont
  f1.close
  $count+=1
end

def energy(a)
  e_total=0.0
  for i in 0..N-1 do
    for j in 0..N-1 do
      if (id=i-1)<0 then id=N-1 end
      e_total+=EnergyMap[a[id][j]][a[i][j]]
      if (jd=j-1)<0 then jd=N-1 end
      e_total+=EnergyMap[a[i][jd]][a[i][j]]
      if (id=i+1)>N-1 then id=0 end
      e_total+=EnergyMap[a[id][j]][a[i][j]]
      if (jd=j+1)>N-1 then jd=0 end
      e_total+=EnergyMap[a[i][jd]][a[i][j]]
    end
  end
  return e_total
end

def init()
#  a=Array.new(N).map{Array.new(N,0)}
  a=Array.new(N) { Array.new(N,0) }
#  p a.map(&:object_id)
  for i in 0..N-1 do
    for j in 0..N/2-1 do
      a[i][j]=1
    end
  end
  (N*10).times do
    ix,iy=rand(N),rand(N)
    jx,jy=rand(N),rand(N)
    a[ix][iy],a[jx][jy]=a[jx][jy],a[ix][iy]
  end
  return a
end

def arange(a)
  da=Array.new(N) { Array.new(N,0) }
  for i in 0..N-1 do
    for j in 0..N-1 do
      da[i][j]=a[i][j]
    end
  end
  ix,iy=rand(N),rand(N)
  jx,jy=rand(N),rand(N)
  da[ix][iy],da[jx][jy]=da[jx][jy],da[ix][iy]
  return da
end

a=init()
#p a.map(&:object_id)
p e0=energy(a)
print_route(a)

N_loop.times do
  if (da=arange(a))==a then next end
#  p da.map(&:object_id)
  e1=energy(da)
  dE = e1 - e0
  if Math::exp(-dE/Temp)>rand() then
    a = da
    p e0=e1
    print_route(a)
  end
end 

